题目

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, n, m and k (1 ≤ k ≤ n ≤ 100, 1 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color j. pi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print - 1.

Examples

input

3 2 2
0 0 0
1 2
3 4
5 6

output

10

input

3 2 2
2 1 2
1 3
2 4
3 5

output

-1

input

3 2 2
2 0 0
1 3
2 4
3 5

output

5

input

3 2 3
2 1 2
1 3
2 4
3 5

output

0

Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

题解

有一些树,每种树上涂有一些颜色, 0 代表可以涂任意一种颜色
颜色编号 1~m ,第 i 个树涂上颜色 j 需要 pij 升颜料
相邻的相同颜色的树可以看成一组

题目要求使用最少的颜料将树分成 k

不看分组部分,题目和 >HDU 5074.Hatsune Miku(2014 鞍山赛区现场赛 E)< 很像

稍微修改下选取颜色的部分

dp[i][j][k] 表示将前 j 棵树分成 i 组并且第 j 棵树颜色为 k 需要的最少的颜料
ln 表示上棵树的颜色, tn 表示当前树的颜色
dp[j][i][tn] = min(dp[j][i][tn],dp[j][i - 1][ln] + p[i][tn]) ln == tn
dp[j][i][tn] = min(dp[j][i][tn],dp[j - 1][i - 1][ln] + p[i][tn]) ln != tn

数比较大,要用 long long 存,不过 Codeforces 要用 __int64

把所有值置为 INF
dp[0][0][0] = 0

思路就这么个思路,乱搞莫名其妙就搞出来了╮(╯▽╰)╭

代码

/*
By:OhYee
Github:OhYee
Blog:http://www.oyohyee.com/
Email:oyohyee@oyohyee.com

かしこいかわいい?
エリーチカ!
要写出来Хорошо的代码哦~
*/

#include <cstdio>
#include <algorithm>
#include <cstring>
#include <cmath>
#include <string>
#include <iostream>
#include <vector>
#include <list>
#include <queue>
#include <stack>
#include <map>
#include <set>
using namespace std;

typedef __int64 LL;

const LL INF = 0x7FFFFFFFFFFFFFFF/2;
const int maxn = 105;

int tree[maxn];
int p[maxn][maxn];
LL dp[maxn][maxn][maxn];
int n,m,k;

void DP(int i,int ln,int tn) {
    for(int j = k;j >= 1;j--)
        if(ln == tn)
            dp[j][i][tn] = min(dp[j][i][tn],dp[j][i - 1][ln] + p[i][tn]);
        else
            dp[j][i][tn] = min(dp[j][i][tn],dp[j - 1][i - 1][ln] + p[i][tn]);
}

void TN(int i,int ln) {
    if(tree[i] == 0) {
        for(int j = 1;j <= m;j++)
            DP(i,ln,j);
    } else {
        DP(i,ln,tree[i]);
    }
}

void LN(int i) {
    if(tree[i - 1] == 0 && i != 1) {
        for(int j = 1;j <= m;j++)
            TN(i,j);
    } else {
        TN(i,tree[i - 1]);
    }
}

bool  Do() {

    if(!(cin >> n >> m >> k))
        return false;

    for(int i = 1;i <= n;i++)
        cin >> tree[i];
    for(int i = 1;i <= n;i++)
        for(int j = 1;j <= m;j++) {
            cin >> p[i][j];
            if(j == tree[i])
                p[i][j] = 0;
        }

    for(int i = 0;i <= k;i++)
        for(int j = 0;j <= n;j++)
            for(int o = 0;o <= m;o++)
                dp[i][j][o] = INF;
    dp[0][0][0] = 0;

    for(int i = 1;i <= n;i++) {
        LN(i);
    }

    LL Min = INF;
    for(int i = 1;i <= m;i++)
        Min = min(Min,dp[k][n][i]);
    if(Min == INF)
        Min = -1;

    cout << Min << endl;

    return true;
}

int main() {
    while(Do());
    return 0;
}